import './block/petalFlower'
import './block/flowerSpread'
import './block/customSapling'
import './block/doublePlant'
import './block/strippedWood'
import './block/vineTwisted'
import './block/stepOn'
import './block/taxiCabLeafFunction'
import './block/fencePlace'
import './block/fenceGate'
import './block/doorFunction'
import './block/trapdoorFunction'
import './block/slabFunction'
import './block/vineFunction'
import './block/quickSand'
import './block/topWaterBlocks'
import './block/leafShear'
import './block/fireflyJar'
import './block/oreXp'
import './block/whisperingWillow'

import 'index'
import 'ambientEffects'
import 'settingsForm'
import 'stealChest'
import 'armorEffects'
import 'weaponEffects'
import 'endBiomeFunctions'
import 'toolFunctions'









// -Tool Durability- //

import { ItemStack, GameMode, world } from '@minecraft/server';

// Arrays for tools and armor items that will lose durability.
const toolTypeIds = [
    "biomes_and_beyond:tungsten_pickaxe",
    "biomes_and_beyond:tungsten_axe",
    "biomes_and_beyond:tungsten_shovel",
    "biomes_and_beyond:tungsten_hoe",
    "biomes_and_beyond:enderium_pickaxe",
    "biomes_and_beyond:enderium_axe",
    "biomes_and_beyond:enderium_shovel",
    "biomes_and_beyond:enderium_hoe"
];

// Helper to get Unbreaking level from an item
function getUnbreakingLevel(item) {
    const enchComp = item.getComponent("minecraft:enchantments");
    if (!enchComp) return 0;
    const unbreaking = enchComp.enchantments.get("unbreaking");
    return unbreaking?.level ?? 0;
}

// Helper to determine if durability should be lost
function shouldLoseDurability(unbreakingLevel) {
    if (unbreakingLevel <= 0) return true;
    return Math.random() < (1 / (unbreakingLevel + 1));
}

// Handle tool durability on block break
world.afterEvents.playerBreakBlock.subscribe(evd => {
    const { player, itemStackBeforeBreak: itemUsed } = evd;
    if (!itemUsed || player.matches({ gameMode: GameMode.creative })) return;

    if (toolTypeIds.includes(itemUsed.typeId)) {
        const playerEquippableComp = player.getComponent("equippable");
        if (!playerEquippableComp) return;

        const unbreakingLevel = getUnbreakingLevel(itemUsed);
        if (!shouldLoseDurability(unbreakingLevel)) return;

        const itemUsedDurabilityComp = itemUsed.getComponent("durability");
        if (!itemUsedDurabilityComp) return;

        itemUsedDurabilityComp.damage += 1;
        const maxDurability = itemUsedDurabilityComp.maxDurability;
        const currentDamage = itemUsedDurabilityComp.damage;
        if (currentDamage >= maxDurability) {
            player.playSound('random.break', { pitch: 1, location: player.location, volume: 1 });
            playerEquippableComp.setEquipment("Mainhand", new ItemStack('minecraft:air', 1));
        } else {
            playerEquippableComp.setEquipment("Mainhand", itemUsed);
        }
    }
});